unit SimpleClassImpl;

interface

type
  TSimpleClass = class
  private
    FI: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure SampleProc(I: Integer; Msg: PWideChar); stdcall;
    function SampleFunc: Integer; stdcall;
  end;

implementation

uses
  SysUtils, Windows;

constructor TSimpleClass.Create;
begin
  inherited;
  FI := 1;
  MessageBox(0, 'SimpleClass has been created', 'Information', MB_OK or MB_ICONINFORMATION)
end;

destructor TSimpleClass.Destroy;
begin
  MessageBox(0, 'SimpleClass being destroyed',
    'Information', MB_OK or MB_ICONINFORMATION);
  inherited;
end;

function TSimpleClass.SampleFunc: Integer;
begin
  Result := FI
end;

procedure TSimpleClass.SampleProc(I: Integer; Msg: PWideChar);
var
  S: String;
begin
  FI := I;
  S := Format('%d: %s', [I, Msg]);
  MessageBox(0, PChar(S), 'SampleProc', MB_OK or MB_ICONINFORMATION)
end;

function CreateSimpleClass: Pointer;
begin
  Result := TSimpleClass.Create
end;

{$WARN UNSAFE_CAST OFF}
procedure FreeSimpleClass(SimpleClassInstance: Pointer);
begin
  TSimpleClass(SimpleClassInstance).Free
end;

exports
  CreateSimpleClass,
  FreeSimpleClass;

end.
